import serial
import time
import struct

def main():
    s = serial.Serial("/dev/ttyS0", 57600)
    key = open('/dev/urandom', 'rb').read(16)
    flag = open('flag.jpg', 'rb').read()

    s.write(key)
    s.write(struct.pack('<L', len(flag)))
    for i in xrange(0, len(flag), 16):
        print(hex(i))
        s.write(flag[i:i+16])
        c = s.read()
        while c != '\x00':
            if c == '\x01':
                return
            c = s.read()

if __name__ == '__main__':
    main()
